Imports System.CodeDom.Compiler

Public Class Form1
    ' The picture.
    Private m_Picture As New Picture

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        txtCode.Select(0, 0)
    End Sub

    Private Sub btnGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGo.Click
        ' Set references.
        Dim code_runner As New SimplerCodeRunner
        code_runner.References.Add("system.dll")
        code_runner.References.Add("system.windows.forms.dll")

        ' Set the Picture parameter for Main.
        code_runner.MainParameter = m_Picture

        ' Run the code.
        Try
            Dim result As Object = _
                code_runner.Run(txtCode.Text)
            If result IsNot Nothing Then
                If TypeOf result Is String Then
                    MessageBox.Show(DirectCast(result, String))
                ElseIf TypeOf result Is Integer Then
                    Me.Text = DirectCast(result, Integer) & " segments"
                End If
            End If
        Catch ex As CompilerException
            Dim txt As String = "Compiler error:" & vbCrLf & vbCrLf
            For Each compiler_error As CompilerError In code_runner.CompilerErrors
                txt &= vbTab & compiler_error.ErrorText & vbCrLf
            Next compiler_error
            MessageBox.Show(txt, _
                "Compiler Error", _
                MessageBoxButtons.OK, _
                MessageBoxIcon.Exclamation)
        Catch ex As Exception
            Dim txt As String = "Runtime error:" & vbCrLf & vbCrLf
            txt &= ex.Message & vbCrLf & vbCrLf
            txt &= ex.InnerException.Message
            MessageBox.Show(txt, _
                "Runtime Error", _
                MessageBoxButtons.OK, _
                MessageBoxIcon.Exclamation)
        End Try

        ' Redraw.
        picCanvas.Invalidate()
    End Sub

    ' Redraw the picture.
    Private Sub picCanvas_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles picCanvas.Paint
        e.Graphics.Clear(Me.BackColor)
        m_Picture.Draw(e.Graphics)
    End Sub
End Class
